###############################################################################################
### Use old scripts to translate maps from CM distance to physical for karyotype circos plots #
setwd('~/Desktop/Old_Desktop/Map Paper/DATA/')
plotdir <- '~/Desktop/Old_Desktop/Map Paper/raw_figures'
x <- c('stringr','reshape2','gdata')
lapply(x, require, character.only = TRUE)

## re-gen /Users/jeffreymiller/software/circos/current/kary.LGs.bands.mandf.txt
## re-gen /Users/jeffreymiller/software/circos/current/kary.highlights.m.txt
## re-gen /Users/jeffreymiller/software/circos/current/fhet.highlights.txt
## re-gen /Users/jeffreymiller/software/circos/current/fhet.marker.highlights.m.txt
## re-gen /Users/jeffreymiller/software/circos/current/plot.snp.count.m.txt
## re-gen /Users/jeffreymiller/software/circos/current/plot.txt

#### Generate table of information for each scaffold (male and female) from map results #### 
count.m <- rep(NA,length(unique(bigfile.m[,1]))) ## Empty vector for building empty data.frame
count.f <- rep(NA,length(unique(bigfile.f[,1])))
scaffolds.m <- data.frame(scaff=count.m,chrm=count.m, lgs=count.m, loci.count=count.m, median.cm=count.m,max.cm=count.m, min.cm=count.m,mean.snp=count.m,max.snp=count.m,min.snp=count.m,median=count.m, snp.middle=count.m, order=count.m,stringsAsFactors = FALSE)
scaffolds.f <- data.frame(scaff=count.f,chrm=count.f, lgs=count.f, loci.count=count.f, median.cm=count.f,max.cm=count.f, min.cm=count.f,mean.snp=count.f,max.snp=count.f,min.snp=count.f,median=count.f, snp.middle=count.f, order=count.f,stringsAsFactors = FALSE)
for (i in 1:length(unique(bigfile.m[,1]))){
  each <- bigfile.m[bigfile.m[,1]==unique(bigfile.m[,1])[i],]
  scaffolds.m$scaff[i] <- as.character(each[1,1])
  scaffolds.m$chrm[i] <- each[1,5]
  scaffolds.m$lgs[i] <- length(unique(each[,5]))
  scaffolds.m$loci.count[i] <- length(each[,1])
  scaffolds.m$median.cm[i] <- median(each$cm)
  scaffolds.m$max.cm[i] <- max(each[,3])
  scaffolds.m$min.cm[i] <- min(each[,3])
  scaffolds.m$mean.snp[i] <- mean(each[,2])
  scaffolds.m$max.snp[i] <- max(each[,2])
  scaffolds.m$min.snp[i] <- min(each[,2])
  scaffolds.m$median[i] <- median(each[,2])
  scaffolds.m$snp.middle[i] <- scaffolds.m$max.snp[i]-scaffolds.m$min.snp[i]/2
} ## Builds a table for all scaffolds, with chm#, number of chrms that the scaff is split between,and scaff statistics

for (i in 1:length(unique(scaffolds.m$chrm))){
  scaffolds.m$order[which(scaffolds.m$chrm==i)][order(as.numeric(as.character(scaffolds.m$median.cm[which(scaffolds.m$chrm==i)])),as.numeric(as.character(scaffolds.m$min.cm[which(scaffolds.m$chrm==i)])),as.numeric(as.character(scaffolds.m$max.cm[which(scaffolds.m$chrm==i)])))] <- c(1:length(scaffolds.m$order[which(scaffolds.m$chrm==i)][order(as.numeric(as.character(scaffolds.m$median.cm[which(scaffolds.m$chrm==i)])),as.numeric(as.character(scaffolds.m$min.cm[which(scaffolds.m$chrm==i)])),as.numeric(as.character(scaffolds.m$max.cm[which(scaffolds.m$chrm==i)])))])) 
}
for (i in 1:length(unique(bigfile.f[,1]))){
  each <- bigfile.f[bigfile.f[,1]==unique(bigfile.f[,1])[i],]
  scaffolds.f$scaff[i] <- as.character(each[1,1])
  scaffolds.f$chrm[i] <- each[1,5]
  scaffolds.f$lgs[i] <- length(unique(each[,5]))
  scaffolds.f$loci.count[i] <- length(each[,1])
  scaffolds.f$median.cm[i] <- median(each$cm)
  scaffolds.f$max.cm[i] <- max(each[,3])
  scaffolds.f$min.cm[i] <- min(each[,3])
  scaffolds.f$mean.snp[i] <- mean(each[,2])
  scaffolds.f$max.snp[i] <- max(each[,2])
  scaffolds.f$min.snp[i] <- min(each[,2])
  scaffolds.f$median[i] <- median(each[,2])
  scaffolds.f$snp.middle[i] <- scaffolds.f$max.snp[i]-scaffolds.f$min.snp[i]/2
}
for (i in 1:length(unique(scaffolds.f$chrm))){
  scaffolds.f$order[which(scaffolds.f$chrm==i)][order(as.numeric(as.character(scaffolds.f$median.cm[which(scaffolds.f$chrm==i)])),as.numeric(as.character(scaffolds.f$min.cm[which(scaffolds.f$chrm==i)])),as.numeric(as.character(scaffolds.f$max.cm[which(scaffolds.f$chrm==i)])))] <- c(1:length(scaffolds.f$order[which(scaffolds.f$chrm==i)][order(as.numeric(as.character(scaffolds.f$median.cm[which(scaffolds.f$chrm==i)])),as.numeric(as.character(scaffolds.f$min.cm[which(scaffolds.f$chrm==i)])),as.numeric(as.character(scaffolds.f$max.cm[which(scaffolds.f$chrm==i)])))])) 
}
row.names(scaffolds.f) <- scaffolds.f$scaff
row.names(scaffolds.m) <- scaffolds.m$scaff
## ^^ made new object with orer in male and female. Will use to orient chrms to males
######################################################################################
#### Fix inverted maps (oriented female to male map) #########
overlap <- data.frame(scaff=scaffolds.m$scaff[scaffolds.m$scaff%in%scaffolds.f$scaff],chrm=scaffolds.m[scaffolds.m$scaff[scaffolds.m$scaff%in%scaffolds.f$scaff],2],male.order=scaffolds.m[scaffolds.m$scaff[scaffolds.m$scaff%in%scaffolds.f$scaff],13],fem.order=scaffolds.f[scaffolds.m$scaff[scaffolds.m$scaff%in%scaffolds.f$scaff],13])
correlations <- c(1:length(unique(overlap$chrm))) # Empty df
LG.F.reorder <- data.frame(scaff=NA,snp=NA,cm=NA,snp_num=NA,LG=NA,M.F=NA,stringsAsFactors = FALSE)
for (i in 1:length(unique(overlap$chrm))){
  correlations[i] <- cor(overlap[which(as.numeric(overlap$chrm)==i),3],overlap[which(as.numeric(overlap$chrm)==i),4])
  LG.F <- bigfile.f[which(as.numeric(bigfile.f$LG)==i),]
  if (as.numeric(correlations[i]) <0){
    LG.F$cm <- max(LG.F$cm)-LG.F$cm
    LG.F.reorder <- rbind(LG.F.reorder, LG.F)
  } else {
    LG.F.reorder <- rbind(LG.F.reorder,LG.F)
  }
} ## Generates a correlation of scaffolds across the chrm. If the chrm is inverted, a new cm is assigned
## average of 90% correlation in the map (excluding chrm 20, which is sex chromosome)
LG.F.reorder <- LG.F.reorder[2:length(LG.F.reorder[,1]),] ## The first row is not real
rownames(LG.F.reorder) <- LG.F.reorder$scaff
## Recheck correlartions ##
scaffolds.f.ro <- data.frame(scaff=count.f,chrm=count.f, lgs=count.f, loci.count=count.f, median.cm=count.f,max.cm=count.f, min.cm=count.f,mean.snp=count.f,max.snp=count.f,min.snp=count.f,median=count.f, snp.middle=count.f, order=count.f)
for (i in 1:length(unique(LG.F.reorder[,1]))){
  each <- LG.F.reorder[LG.F.reorder[,1]==unique(LG.F.reorder[,1])[i],]
  scaffolds.f.ro$scaff[i] <- as.character(each[1,1])
  scaffolds.f.ro$chrm[i] <- each[1,5]
  scaffolds.f.ro$lgs[i] <- length(unique(each[,5]))
  scaffolds.f.ro$loci.count[i] <- length(each[,1])
  scaffolds.f.ro$median.cm[i] <- median(each$cm)
  scaffolds.f.ro$max.cm[i] <- max(each[,3])
  scaffolds.f.ro$min.cm[i] <- min(each[,3])
  scaffolds.f.ro$mean.snp[i] <- mean(each[,2])
  scaffolds.f.ro$max.snp[i] <- max(each[,2])
  scaffolds.f.ro$min.snp[i] <- min(each[,2])
  scaffolds.f.ro$median[i] <- median(each[,2])
  scaffolds.f.ro$snp.middle[i] <- scaffolds.f.ro$max.snp[i]-scaffolds.f.ro$min.snp[i]/2
} ## New scaffold table with female chrm in correct order and cms updataed
for (i in 1:length(unique(scaffolds.f.ro$chrm))){
  scaffolds.f.ro$order[which(scaffolds.f.ro$chrm==i)][order(as.numeric(as.character(scaffolds.f.ro$median.cm[which(scaffolds.f.ro$chrm==i)])),as.numeric(as.character(scaffolds.f.ro$min.cm[which(scaffolds.f.ro$chrm==i)])),as.numeric(as.character(scaffolds.f.ro$max.cm[which(scaffolds.f.ro$chrm==i)])))] <- c(1:length(scaffolds.f.ro$order[which(scaffolds.f.ro$chrm==i)][order(as.numeric(as.character(scaffolds.f.ro$median.cm[which(scaffolds.f.ro$chrm==i)])),as.numeric(as.character(scaffolds.f.ro$min.cm[which(scaffolds.f.ro$chrm==i)])),as.numeric(as.character(scaffolds.f.ro$max.cm[which(scaffolds.f.ro$chrm==i)])))])) 
}
row.names(scaffolds.f.ro) <- scaffolds.f.ro$scaff

overlap <- data.frame(scaff=scaffolds.m$scaff[scaffolds.m$scaff%in%scaffolds.f.ro$scaff],chrm=scaffolds.m[scaffolds.m$scaff[scaffolds.m$scaff%in%scaffolds.f.ro$scaff],2],male.order=scaffolds.m[scaffolds.m$scaff[scaffolds.m$scaff%in%scaffolds.f.ro$scaff],13],fem.order=scaffolds.f.ro[scaffolds.m$scaff[scaffolds.m$scaff%in%scaffolds.f.ro$scaff],13])
for (i in 1:length(unique(overlap$chrm))){
  correlations[i] <- cor(overlap[overlap$chrm==i,3],overlap[overlap$chrm==i,4])
}
#overlap.f <- scaffolds.f.ro[scaffolds.f.ro$scaff%in%scaffolds.m$scaff,] # Those that are in both M and F
#overlap.f <- overlap.f[order(as.numeric(overlap.f$scaff)),] ##NAs introduced
#print('Expect NAs')
overlap <- data.frame(scaff=overlap.m$scaff,chrm=overlap.m$chrm,f.order=overlap.f$order,f.loci.count=overlap.f$loci.count,m.order=overlap.m$order, m.loci.count=overlap.m$loci.count, stringsAsFactors = FALSE)
for (i in 1:length(unique(overlap$chrm))){
  correlations[i] <- cor(overlap[overlap$chrm==i,3],overlap[overlap$chrm==i,5])
} ## Makes a vector of correlations for each chrm. All 90% or better 
row.names(scaffolds.f.ro) <- scaffolds.f.ro$scaff
row.names(scaffolds.m) <- scaffolds.m$scaff
#### use scaffolds.f.ro and scaffolds.m #######
#### Orient Scaffolds directions #####
## Scaffold directions are chosen based on correlation with cm (neg or pos orients each)
for (i in 1:length(scaffolds.f.ro[,1])){
  scaffs <- bigfile.f[bigfile.f[,1]==scaffolds.f.ro[i,1],]
  scaffolds.f.ro$correlation[i] <- cor(scaffs$snp,scaffs$cm)
  if(is.na(scaffolds.f.ro$correlation[i])){
    scaffolds.f.ro$orientation[i] <- sample(0:1,1)  
  } else{
    if(scaffolds.f.ro$correlation[i] > 0){
      scaffolds.f.ro$orientation[i] <- 1
    }
    if(scaffolds.f.ro$correlation[i] < 0){
      scaffolds.f.ro$orientation[i] <- 0
    }
  }
}      
for (i in 1:length(scaffolds.m[,1])){
  scaffs <- bigfile.m[bigfile.m[,1]==scaffolds.m[i,1],]
  scaffolds.m$correlation[i] <- cor(scaffs$snp,scaffs$cm)
  if(is.na(scaffolds.m$correlation[i])){
    scaffolds.m$orientation[i] <- sample(0:1,1)  
  } else{
    if(scaffolds.m$correlation[i] > 0){
      scaffolds.m$orientation[i] <- 1
    }
    if(scaffolds.m$correlation[i] < 0){
      scaffolds.m$orientation[i] <- 0
    }
  }
} 
## 1 -> physical distance is positively correlated w mapping position
## 0 -> physical distance is negatively correlated w mapping position
#### Scaffolds are now oriented within chrms ######
#### SEX specific geneorders ####
kfish.genes$scaff <- cnvrt[as.character(kfish.genes$scaff)]
kfish.genes.f <- data.frame(kfish.genes[kfish.genes$scaff%in%scaffolds.f$scaff,],
                            kfish.LG=scaffolds.f.ro[as.character(kfish.genes.f$scaff),2],
                            kfish.order=NA,
                            kfish.order.scaff=NA, 
                            row.names=row.names(kfish.genes[kfish.genes$scaff%in%scaffolds.f$scaff,]),
                            stringsAsFactors=FALSE) ## limit to only sex specific scaffolds

for (i in 1:length(unique(kfish.genes.f$scaff))){
  kfish.genes.f[which(kfish.genes.f$kfish.LG==unique(kfish.genes.f$scaff)[i]&kfish.genes.f$scaff==unique(kfish.genes.f$scaff)[i]),6] <- order(as.numeric(kfish.genes.f[which(kfish.genes.f$kfish.LG==unique(kfish.genes.f$scaff)[i]&kfish.genes.f$scaff==unique(kfish.genes.f$scaff)[i]),3]))
}

for(i in 1:length(unique(kfish.genes.f$kfish.LG))){
  kfish.genes.f[which(kfish.genes.f$kfish.LG==unique(kfish.genes.f$kfish.LG)[i]),7] <- order(as.numeric(kfish.genes.f[which(kfish.genes.f$kfish.LG==unique(kfish.genes.f$kfish.LG)[i]),6]),as.numeric(kfish.genes.f[which(kfish.genes.f$kfish.LG==unique(kfish.genes.f$kfish.LG)[i]),3]))
}

kfish.genes.f <- data.frame(kfish.genes[kfish.genes[,2] %in% scaffolds.f.ro[,1],],
                            kfish.LG=NA,
                            kfish.order=NA,
                            kfish.order.scaff=NA,
                            row.names=kfish.genes[kfish.genes[,2] %in% scaffolds.f.ro[,1],1],
                            stringsAsFactors=FALSE) ## limit to only sex specific scaffolds

kfish.genes.m <- data.frame(kfish.genes[kfish.genes[,2] %in% scaffolds.m[,1],],
                            kfish.LG=NA,
                            kfish.order=NA,
                            kfish.order.scaff=NA, 
                            row.names=kfish.genes[kfish.genes[,2] %in% scaffolds.m[,1],1],
                            stringsAsFactors=FALSE) ## limit to only sex specific scaffolds

kfish.genes.f$kfish.LG <- scaffolds.f.ro[as.character(kfish.genes.f$scaff),2] ## 2nd col is chrm
kfish.genes.f$kfish.order.scaff <- scaffolds.f.ro[as.character(kfish.genes.f$scaff),13] ## 13th col is order
kfish.genes.m$kfish.LG <- scaffolds.m[as.character(kfish.genes.m$scaff),2] ## 2nd col is chrm
kfish.genes.m$kfish.order.scaff <- scaffolds.m[as.character(kfish.genes.m$scaff),13] ## 13th col is order
#######END###################

#################### Summary: 
#################### fish12.kfish2 contains gene names and orthoID for all genes that have orthologs- 17917 genes
#################### kfish.genes.m/f contain map/sex specfice genes that are found on scaffolds mapped in m/f - 
#################### OF the 34,925 genes in the model, 2,267 do not have position information and 2,138 are split genes (30,520)
#################### kfish.genes contains these 30,520 
#################### 23,258/30,520 were mapped in male, 22727/30,520 in female. 
#################### 8,867/34,925 have a 1 to 1 ortholog in at least one of the comparative species.
########################################################################################################################
#########Female##########









