##### Takes the raw male and female maps to generate circos inputs and plots ####
x <- c('stringr','reshape2','gdata')
lapply(x, require, character.only = TRUE)
setwd('~/Desktop/Old_Desktop/Map Paper/DATA/')

#### Genereate table of each marker position for each sex ####
LG.ML <- read.table('16.9.8.ML_corrected_map.csv', header=TRUE, 
                    stringsAsFactors = FALSE,sep = ',')

## This map has the old an incorrect names due to multiple genomes. This script changes toNCBI names ##
LGP1 <- LG.ML[grep('P1',LG.ML$Group),]
LGP2 <- LG.ML[grep('P2',LG.ML$Group),]
LGP1$Group <- gsub('LG','',LGP1$Group)
LGP2$Group <- gsub('LG','',LGP2$Group)
LGP1$Group <- gsub('P1','',LGP1$Group)
LGP2$Group <- gsub('P2','',LGP2$Group)
chrm.list <- unique(LGP2$Group)
bigfile.m <- data.frame(scaff=gsub('SCFLD','',colsplit(string=LGP1$Locus,'_',names= c('rm','scaff','snp'))[,2]),
                        snp=colsplit(string=LGP1$Locus,'_', names= c('rm','scaff','snp'))[,3],
                        cm=LGP1$Position,snp_num=LGP1$Nr,LG=LGP1$Group,M.F='M',
                        stringsAsFactors = FALSE)

bigfile.f <- data.frame(scaff=gsub('SCFLD','',colsplit(string=LGP2$Locus,'_', names= c('rm','scaff','snp'))[,2]),
                        snp=colsplit(string=LGP2$Locus,'_', names= c('rm','scaff','snp'))[,3],
                        cm=LGP2$Position,snp_num=LGP2$Nr,LG=LGP2$Group,M.F='F', 
                        stringsAsFactors = FALSE)
#########################################################
#### Tempor remove split scaffolds #####
bigfile <- data.frame(rbind(bigfile.f,bigfile.m), stringsAsFactors = FALSE)
LGcount <- rep.int(NA,times = length(bigfile$scaff))
for(i in 1:length(LGcount)){
  LGcount[i] <- dim(table(bigfile[which(bigfile$scaff==as.character(bigfile$scaff[i])),5]))
}
LGcount <- as.character(unique(bigfile[which(as.numeric(LGcount)>1),1]))       
bigfile.f <- bigfile.f[!as.character(bigfile.f$scaff)%in%as.character(LGcount),]
bigfile.m <- bigfile.m[!as.character(bigfile.m$scaff)%in%as.character(LGcount),]
rm(bigfile)
######################################
#### Covert to the corrected NCBI Scaffolds #####
 AW.conv <- read.table('Scaffold_names_conversion_table.csv', 
                      stringsAsFactors = FALSE, header = TRUE, sep = ',')

cnvrt <- data.frame(out=AW.conv$RefSeq.Accession.version, row.names = gsub('Scaffold','',AW.conv$corrected))
bigfile.f$scaff <- cnvrt[as.character(as.numeric(bigfile.f$scaff)),]
bigfile.m$scaff <- cnvrt[as.character(as.numeric(bigfile.m$scaff)),]

###########################################
###### LGs Rename to Microsat paper LGs (BLAST) ##########
microsats <- read.table('Waits.csv',sep = ',', header = TRUE, stringsAsFactors = FALSE)
microsats <- microsats[1:238,1:5]
row.names(microsats) <- gsub(' ','',microsats$Locus)
write.table(paste('>',microsats$Locus,'\n',microsats$DNA.Sequence,'\n',sep = ''),quote = FALSE,file = 'BLAST.fasta',row.names = FALSE)
## BLAST to killifish genome 
results <- read.table('blast.results.txt', sep = '\t', stringsAsFactors = FALSE)
results[281,1] <- 'LDHB1033'
results[282,1] <- 'LDHB654'
results$V1 <- gsub(' ','',results$V1)

set <- results[which(results$V1==unique(results$V1)[i]),]
set <-  results[which.min(as.numeric(set$V13)),] 
for (i in 2:length(unique(results$V1))){
  bull <- results[which(results$V1==unique(results$V1)[i]),]
  bull <-  bull[which.min(as.numeric(bull$V13)),]
  set <- rbind(set,bull)
}
results <- set
bigfile <- data.frame(rbind(bigfile.f,bigfile.m), stringsAsFactors = FALSE)
convert <- paste(bigfile$scaff,bigfile$LG,sep = '@')
convert <- unique(convert)
convert <- colsplit(convert,'@',names=c('scaff','chrm'))
row.names(convert) <- convert$scaff 

convert.chr <- data.frame(gene=results$V1,ncbi=results$V4,
                          micromap=microsats[as.character(results$V1),2],
                          RADMAP=convert[as.character(results$V4),2],
                          stringsAsFactors = FALSE)

#agp <- read.delim('~/Desktop/MAP_FIGURES/unsplit_merge.agp',header=F, comment.char="#")
#agp <- agp[which(agp$V5=='W'),]
#row.names(agp) <- agp$V6
#convert.chr <- data.frame(results[,1:2],micro.map=microsats[results$V1,2],radmap=gsub('chr','',agp[as.character(cnvrt[as.character(gsub('Scaffold','',results$V2)),]),1]))

homologous <- c(9,12,11,1,8,6,5,16,13,17,18,7,3,4,22,20,10,6,14,19,23,21,10,2)
homologous[18] <- 15
homologous[23] <- 24
homologous_microst.radmap <- c(1:24) ### names are the microsat map
names(homologous_microst.radmap) <- homologous
homologous_microst.radmap[as.character(convert.chr$RADMAP)]
homologous_microst.radmap <- data.frame(homologous_microst.radmap,BS=NA)
write.table(file = "WAITSCONVTABLE.csv",
            data.frame(convert.chr,convertedto=homologous_microst.radmap[as.character(as.numeric(convert.chr$RADMAP)),1]))

#homologous <- data.frame(microsat=names(homologous_microst.radmap),row.names = homologous_microst.radmap,stringsAsFactors = FALSE)
### use 'homologous' to translate names ### 
bigfile.f$LG <- as.numeric(homologous_microst.radmap[as.character(as.numeric(bigfile.f$LG)),1])
bigfile.m$LG <- as.numeric(homologous_microst.radmap[as.character(as.numeric(bigfile.m$LG)),1])
###############################################
#### Write files for each sex specific map ####
write.csv(file='Fem.map.csv', 
          data.frame(Scaffold_ID=bigfile.f$scaff, 
                     scaffold_position=bigfile.f$snp, 
                     LG=bigfile.f$LG, 
                     genetic_position=bigfile.f$cm),
          row.names = FALSE, quote = FALSE)

write.csv(file='Male.map.csv',
          data.frame(Scaffold_ID=bigfile.m$scaff, 
                     scaffold_position=bigfile.m$snp, 
                     LG=bigfile.m$LG,
                     genetic_position=bigfile.m$cm),
          row.names = FALSE, quote = FALSE)
##########################################

###################################################################################
###################################################################################
### Before proceeding to 2_GenDotCorPlot, use ALLMAPS on FARM to merge these ######
### maps, and LIFTOVER to generate a new gff ro read into 2_ ######################
###################################################################################


